\section{Exponents}

\begin{minipage}{0.25\linewidth}
	\[ a^m \times a^n = a^{m+n} \]
	\[ (\frac{a}{b})^m = \frac{a^m}{b^m} \]
\end{minipage}
\begin{minipage}{0.25\linewidth}
	\[ a^m \div a^n = a^{m-n}  \]
	\[ a^0 = 1 \]
\end{minipage}
\begin{minipage}{0.25\linewidth}
	\[ (a^m)^n = a^{mn} \]
	\[ a^{-m} = \frac{1}{a^m} \]
\end{minipage}
\begin{minipage}{0.25\linewidth}
	\[ (ab)^m = a^mb^m \]
	\[ a^{\frac{m}{n}} = \sqrt[n]{a^m} \]
\end{minipage}

\section{Quadratic Equations}
\begin{minipage}{0.5\linewidth}
	\[ ax^2 + bx + c = 0 \]	
\end{minipage}
\begin{minipage}{0.5\linewidth}
	\[ x_{1,2} = \frac{-b \pm \sqrt{b^2-4ac}}{2a} \]		
\end{minipage}

\section{Logarithms}
\begin{minipage}{0.25\linewidth}
	\[ ln(xy) = ln(x) + ln(y) \]
	\[ ln(\frac{x}{y}) = ln(x) - ln(y) \]
\end{minipage}
\begin{minipage}{0.25\linewidth}
	\[ ln(x^y) = y ln(x)  \]
	\[ ln(e) = 1 \]
\end{minipage}
\begin{minipage}{0.25\linewidth}
	\[ ln(1) = 0 \]
	\[ ln(\frac{1}{x}) = - ln(x) \]
\end{minipage}

\section{Differentiation}
\begin{minipage}{0.5\linewidth}
	\textbf{Product Rule}
	\[ h((x) = f(x)g(x) \textrm{ then } f'(x)g(x)+g'(x)f(x) \]
\end{minipage}
\begin{minipage}{0.5\linewidth}
	\textbf{Quotient Rule}
	\[ h(x) = \frac{f(x)}{g(x)} \textrm{ then } \frac{f'(x)g(x)-g'(x)f(x)}{g(x)^2} \]
\end{minipage}

\begin{minipage}{0.5\linewidth}
\textbf{Chain Rule}
	\[ h(x) = f(g(x)) = \textrm{ then } h'(x)=f'(g(x))g'(x) \]
\end{minipage}

\subsection{Cheatsheet}
\begin{minipage}{0.25\linewidth}
	\[ f(x)=x, f'(x)=1 \]
	\[ f'(x)= |x|' = \frac{x}{|x|} \]
	\[ f'(x)= (a^x)' = ln(a)*a^x \]
\end{minipage}
\begin{minipage}{0.25\linewidth}
	\[ \nabla | \vec{x} | = \frac{\vec{x}^T}{|\vec{x}|} \]
	\[ f'(x)= (sin(x))' = cos(x) \]
	\[ f'(x)= (cos(x))' = -sin(x) \]
	\[ f'(x)= (ln(x))' = \frac{1}{x} \]	
\end{minipage}
\begin{minipage}{0.25\linewidth}
	\[ f'(x)= (\frac{1}{g(x)})' = - \frac{g'(x)}{g^2(x)}\]		
\end{minipage}
\begin{minipage}{0.25\linewidth}
	
\end{minipage}

\section{Graph of a Function}
\begin{minipage}{0.5\linewidth}
The graph of the function 
	\[ f: \begin{cases}
		\mathbb{R} \rightarrow \mathbb{R}^2 \\
		t \rightarrow (cos(t),sin(t))
	\end{cases} \]
\end{minipage}
\begin{minipage}{0.5\linewidth}
is
	\[ \textrm{graph } f(x) = \{ (t,x,y) \in \mathbb{R}^3 | (x,y) = f(t) \land t \in \mathbb{R} \} \]
	\[ = \{(t,cos(t),sin(t) \in \mathbb{R}^3 | t \in \mathbb{R} \} \]
\end{minipage}

\section{Gradient}

\[ \nabla f(x) =  \begin{pmatrix} \frac{\partial}{\partial x_1} f(x), \frac{\partial}{\partial x_2} f(x), \hdots \frac{\partial}{\partial x_n} f(x) \end{pmatrix} \] 

\textbf{Gradient Descent Algorithm} \\
\begin{minipage}{0.5\linewidth}
	\begin{itemize}
		\item Calculate the gradient
		\item Insert the starting point into the gradient
		\item Use the forumla with the starting point
	\end{itemize}
\end{minipage}
\begin{minipage}{0.5\linewidth}
	\centering
	\[ x_{next},y_{next} = (x,y) - \lambda \nabla f(x,y)\]
	where $\lambda$ is the learning rate
\end{minipage}

\section{Jacobian Matrix}
The matrix of a differnetiable function $f:\mathbb{R}^n \rightarrow \mathbb{R}^m$ is a $n \times m$ matrix with all first partial derivatives.

\[ J_f(x_0) = \begin{pmatrix}
	\partial_{x_1}f_1(x_0) & \partial_{x_2}f_1(x_0) \hdots &  \partial_{x_n}f_1(x_0) \\
	\partial_{x_1}f_2(x_0) & \partial_{x_2}f_2(x_0) \hdots & \partial_{x_n}f_2(x_0) \\
	\vdots & \vdots & \vdots \\
	\partial_{x_1}f_m(x_0) & \partial_{x_2}f_m(x_0) \hdots & \partial_{x_n}f_m(x_0) \\
 \end{pmatrix} \]
 
The jabociban matrix plays the role of the first order derivative of a vector valued function and can be used to approximate a vector valued function

\[ f(x) = f(x_0) + J_f(x_0) * (x - x_0) \textrm{ for } x \approx = x_0 \] 

\textbf{Chain Rule} \\
\begin{minipage}{0.35\linewidth}
	\centering
	\includegraphics[width=\linewidth]{src/chain-rule.png}
\end{minipage}
\begin{minipage}{0.5\linewidth}
	According to the chain rule we get for the jabociban
	\[ J_{s \circ s \circ f} = J_s s[f(x,y)] * J_s f(x,y) * J_f(x,y) \]
	\[ = J_s(x,y) * J_s(x,y) * J_f(x,y) \]
\end{minipage}

\subsection{Linerarisation}
Let $f: \mathbb{R} \rightarrow \mathbb{R}^m$ be a vector-valued function of $n$ variables and $x_0$ in $\mathbb{R}^n$ be an arbitrary point from the domain of definition of $f$. if $J_f(x_0)=\frac{\partial f}{\partial x} |_{x=x_0}$ is

\[ f(x) \approx f(x_0) + J_f(x_0) * [\begin{pmatrix} x \\ y\end{pmatrix} - \begin{pmatrix} x_0 \\ y_0 \end{pmatrix} ] \textrm{ for x } \approx x_0 \] 


\section{Hessian Matrix}
The hessian Matrix is symetric.

\[ H_f(x_0) = \begin{pmatrix}
	\frac{\partial}{\partial_{x_1}} \frac{\partial}{\partial_{x_1}} f(x_0) & 
	\frac{\partial}{\partial_{x_1}} \frac{\partial}{\partial_{x_2}} f(x_0) &
	\hdots & 
	\frac{\partial}{\partial_{x_1}} \frac{\partial}{\partial_{x_n}} f(x_0) \\
	
	\frac{\partial}{\partial_{x_2}} \frac{\partial}{\partial_{x_1}} f(x_0) & 
	\frac{\partial}{\partial_{x_2}} \frac{\partial}{\partial_{x_2}} f(x_0) &
	\hdots & 
	\frac{\partial}{\partial_{x_2}} \frac{\partial}{\partial_{x_n}} f(x_0) \\
	\vdots & \vdots & \ddots \\
	
	\frac{\partial}{\partial_{x_n}} \frac{\partial}{\partial_{x_1}} f(x_0) & 
	\frac{\partial}{\partial_{x_n}} \frac{\partial}{\partial_{x_2}} f(x_0) &
	\hdots & 
	\frac{\partial}{\partial_{x_n}} \frac{\partial}{\partial_{x_n}} f(x_0) \\

\end{pmatrix} \]
 
\subsection{Quadratic Form}
 
\[ \vec{x}^\top M \vec{x} = f(x,y,z) = \begin{pmatrix} x & y & z \end{pmatrix} 
\begin{pmatrix}
 	2 & 0 & 0 \\
 	0 & 1 & -1 \\
 	0 & -1 & 3 
\end{pmatrix} * 
\begin{pmatrix}
	x \\
	y \\
	z 	
\end{pmatrix} = 2x^2 +y^2 +3z^2 - 2yz
\]
 
\section{Likelihood}
Find those parameters $\vec{q}$ that maximize:

\[ p_{joint} = p_{\vec{q}}(\vec{i}_1)*p_{\vec{q}}(\vec{i}_2) \hdots  p_{\vec{q}}(\vec{i}_n) = (1-p_{\vec{q}}(\vec{j}_1)) *(1- p_{\vec{q}}(\vec{j}_2)) *(1-p_{\vec{q}}(\vec{j}_n)) \]

 in machine learning $p_{join}(\vec{q})$ is called likelihood function (we use the symbol $l(\vec{q}))$.
 
 it is much simpler to seek maximum values of the alogarith of the likelihood function, which is called log-likelihood function. 
 
 \[ ln(l(\vec{q})) = ln(p_{joint}(\vec{q})) \] 
 
 In machine learning we seek to minimize cost, therefore a suitable cost function is the negative of the log-likelihood function, which is called negative log-likelihood. 
 
 \[ ln(l(\vec{q}) = - \sum_{k=1}^n ln(p_{\vec{q}}(\vec{l}_k))- \sum_{k=1}^m ln(1-p_{\vec{q}}(\vec{j}_k)) \]
 
 \subsection{Continous Random Variables}
 X is said to be a continuous random variable if there exists a function f(x) associated with X called the probability density function with the properties.
 
\[ f(x) \geq 0 \textrm{ for all }x \]
\[ \int_{-\infty}^\infty f(x)dx = 1 \]
\[ P(a < X < b = \int_a^b f(x)dx = F(b) - F(a) \]


